//
//  bit_vector.h
//  caqe
//
//  Copyright (c) 2015 - 2016, Leander Tentrup, Saarland University
//
//  Licensed under Apache License v2.0, see LICENSE.txt for information
//

#ifndef __caqe__bit_vector__
#define __caqe__bit_vector__

#include <stdbool.h>
#include <stddef.h>

#define BIT_VECTOR_NO_ENTRY UINT64_MAX

typedef struct bit_vector bit_vector;

bit_vector* bit_vector_init(size_t offset, size_t max_num);
void bit_vector_free(bit_vector*);
void bit_vector_reset(bit_vector*);
void bit_vector_add(bit_vector*, size_t);
void bit_vector_remove(bit_vector*, size_t);
bool bit_vector_contains(bit_vector*, size_t);
void bit_vector_update_or(bit_vector* target, bit_vector* source);
size_t bit_vector_min(bit_vector*);
size_t bit_vector_max(bit_vector*);
bool bit_vector_equal(bit_vector*, bit_vector*);

// Iteration
size_t bit_vector_init_iteration(bit_vector*);
bool bit_vector_iterate(bit_vector*);
size_t bit_vector_next(bit_vector*);


#endif /* defined(__caqe__bit_vector__) */
