//
//  semaphore.h
//  caqe
//
//  Copyright (c) 2016, Leander Tentrup, Saarland University
//
//  Licensed under Apache License v2.0, see LICENSE.txt for information
//

#ifndef semaphore_h
#define semaphore_h

#include <stdio.h>

#include <pthread.h>

struct semaphore {
    pthread_mutex_t mutex;
    pthread_cond_t condition;
    
    size_t value;
};

typedef struct semaphore semaphore;

void semaphore_init(semaphore*, size_t);
void semaphore_wait(semaphore*);
void semaphore_post(semaphore*);

#endif /* semaphore_h */
