//
//  statistics.h
//  caqe
//
//  Copyright (c) 2015, Markus Rabe, University of California, Berkeley
//
//  Licensed under Apache License v2.0, see LICENSE.txt for information
//

#ifndef __caqe__statistics__
#define __caqe__statistics__

#include <stdio.h>
#include "vector.h"

typedef struct {
    int calls_num;
    double accumulated_value;
    double max;
    double min;
    int_vector* exponential_histogram; // stores the histogram of the logarithm of the microseconds.
    double factor; // factor applied to value before adding it to histogram
    double time_stamp;
} Stats;

Stats* statistics_init(double factor);
void statistics_free(Stats*);
void statistic_add_value(Stats* s, double v);
void statistics_print(Stats* s);
// For using it as a timer:
void statistics_start_timer(Stats* s);
void statistics_stop_and_record_timer(Stats* s);
void statistics_print_time(Stats* s);

#endif /* defined(__caqe__statistics__) */
